module Command
    ( Command
    , AccelerationCommand (..)
    , TurningCommand (..)
    , showCommand
    , sendCommand
    , sendCommands
    )
    where

import System.IO
-- import GHC.Base (inline)

type Command = (Maybe AccelerationCommand, Maybe TurningCommand)
data AccelerationCommand = CmdA | CmdB deriving (Eq, Show)
data TurningCommand = CmdL | CmdR deriving (Eq, Show)

showCommand :: Command -> String
showCommand (x, y) = f x ++ g y ++ ";"
  where
    f Nothing = ""
    f (Just CmdA) = "a"
    f (Just CmdB) = "b"
    g Nothing = ""
    g (Just CmdL) = "l"
    g (Just CmdR) = "r"

sendCommand :: Handle -> Command -> IO ()
sendCommand h cmd = hPutStr h (showCommand cmd) >> hFlush h

sendCommands :: Handle -> [Command] -> IO ()
sendCommands h cs = mapM_ (hPutStr h . showCommand) cs >> hFlush h
